dofile( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local enemies = EntityGetWithTag( "destruction_target" )

if ( enemies ~= nil ) then
	for i,enemy_id in ipairs(enemies) do	
		local px, py = EntityGetTransform( enemy_id )
		distance = math.sqrt( ( x - px ) ^ 2 + ( y - py ) ^ 2 )
        if ( distance < 30 ) then           
            SetRandomSeed( px + 325, py - 235 )
            local opts = { "physics_minecart", "physics_box_explosive", "physics_barrel_oil" }
            local rnd = Random( 1, #opts )
            local opt = opts[rnd]
    
            local new_ent = EntityLoad("data/entities/props/" .. opt .. ".xml", px, py)
            EntityLoad("data/entities/particles/image_emitters/transmutation_effect.xml", px, py)
            
            EntitySave(enemy_id, "mods/object_polymorph/tmp/e_" .. tostring(enemy_id) .. ".xml")
    
            EntityAddComponent(new_ent, "VariableStorageComponent", {
                name = "oldpath",
                value_string = "mods/object_polymorph/tmp/e_" .. tostring(enemy_id) .. ".xml"
            })
    
            EntityAddComponent(new_ent, "LuaComponent", {
                enable_coroutines="1",
                script_source_file="mods/object_polymorph/files/scripts/polymorph_return.lua",
                execute_on_added="1",
                execute_every_n_frame="-1",
                execute_times="1"
            })
    
            EntityKill( enemy_id )
        end
        
    end
    
end